Index: source/class/pf/theme/Appearance.js
===================================================================
--- source/class/pf/theme/Appearance.js	(revision 146)
+++ source/class/pf/theme/Appearance.js	(revision 146)
@@ -0,0 +1,46 @@
+qx.Theme.define("pf.theme.Appearance",
+{
+  extend : qx.theme.modern.Appearance,
+
+  appearances :
+  {
+    "groupbox" :
+    {
+      style : function(states)
+      {
+        return {
+          legendPosition : "middle"
+        };
+      }
+    },
+    
+    "groupbox/legend" :
+    {
+      alias : "atom",
+
+      style : function(states)
+      {
+        return {
+          paddingRight    : 4,
+          paddingLeft     : 4,
+          paddingTop      : 2,
+          paddingBottom   : 2,
+          marginRight     : 10,
+          marginLeft      : 10,
+          decorator       : "group"
+        };
+      }
+    },
+    
+    "groupbox/frame" :
+    {
+      style : function(states)
+      {
+        return {
+          padding : [ 12, 9 ],
+          decorator  : "group"
+        };
+      }
+    }
+  }
+});
Index: source/class/pf/theme/Theme.js
===================================================================
--- source/class/pf/theme/Theme.js	(revision 146)
+++ source/class/pf/theme/Theme.js	(revision 146)
@@ -0,0 +1,11 @@
+qx.Theme.define("pf.theme.Theme",
+{
+  meta :
+  {
+    color      : qx.theme.modern.Color,
+    decoration : qx.theme.modern.Decoration,
+    font       : qx.theme.modern.Font,
+    icon       : qx.theme.icon.Tango,
+    appearance : pf.theme.Appearance
+  }
+});
Index: source/class/pf/ui/ColorPopup.js
===================================================================
--- source/class/pf/ui/ColorPopup.js	(revision 146)
+++ source/class/pf/ui/ColorPopup.js	(revision 146)
@@ -0,0 +1,33 @@
+qx.Class.define("pf.ui.ColorPopup",
+{
+    extend: qx.ui.control.ColorPopup,
+    
+    construct: function(colors) {
+        this.base(arguments);
+        this.setFocusable(true);
+        this._remove(this.getChildControl("auto-button"));
+
+        if (colors) {
+            var clength = colors.length;
+            for (var i = 0; i < this.__fieldNumber && i < clength; i++) {
+                var field = this.getChildControl("field#" + i);
+                field.setBackgroundColor(colors[i]);
+            }
+        }
+
+        this.addListener("keypress", function(ev) {
+                if (ev.getKeyIdentifier() == "Escape") {
+                    this.hide()
+                }
+            });
+    },
+    
+    members:
+    {
+        open: function()
+        {
+            this.show();
+            this.focus();
+        }
+    }
+});
Index: source/class/pf/ui/SelectBox.js
===================================================================
--- source/class/pf/ui/SelectBox.js	(revision 146)
+++ source/class/pf/ui/SelectBox.js	(revision 146)
@@ -0,0 +1,40 @@
+qx.Class.define("pf.ui.SelectBox",
+{
+    extend: qx.ui.form.SelectBox,
+    
+    members:
+    {
+        addItem: function(vText, vValue)
+        {
+            var item = new qx.ui.form.ListItem(vText, null, vValue);
+            this.add(item);
+            
+            return item;
+        },
+        
+        addNumItem: function(vText, vValue)
+        {
+            var item = new qx.ui.form.ListItem(vText, null, vValue.toString());
+            this.add(item);
+            
+            return item;
+        },
+        
+        getSelectedValue: function()
+        {
+            var items = this.getChildControl("list").getSelection();
+            if (items && items.length == 1) {
+                return items[0].getModel();
+            } else {
+                return null;
+            }
+        },
+
+        selectByValue: function(value)
+        {
+            var list = this.getChildControl("list");
+            var models = new Array(value);
+            list.setModelSelection(models);
+        }
+    }
+});
Index: source/class/pf/ui/TextField.js
===================================================================
--- source/class/pf/ui/TextField.js	(revision 79)
+++ source/class/pf/ui/TextField.js	(revision 146)
@@ -2,5 +2,5 @@
 qx.Class.define("pf.ui.TextField",
 {
-    extend: qx.legacy.ui.form.TextField,
+    extend: qx.ui.form.TextField,
     
     construct: function(v) {
Index: source/class/pf/ui/canvas/Canvas.js
===================================================================
--- source/class/pf/ui/canvas/Canvas.js	(revision 72)
+++ source/class/pf/ui/canvas/Canvas.js	(revision 146)
@@ -1,11 +1,12 @@
 qx.Class.define("pf.ui.canvas.Canvas",
 {
-    extend: qx.legacy.ui.basic.Atom,
+    extend: qx.ui.core.Widget,
     
     construct: function() {
         this.base(arguments);
+        
         this.addListener("appear", function(e) {
                 if (!this.jg) {
-                    var element = this.getElement();
+                    var element = this.getContainerElement().getDomElement();
                     this.jg = new jsGraphics(element);
                     // FIXME: get from qx
@@ -14,5 +15,5 @@
             }, this);
     },
-    
+
     members:
     {
Index: source/class/pf/ui/canvas/Plotter.js
===================================================================
--- source/class/pf/ui/canvas/Plotter.js	(revision 118)
+++ source/class/pf/ui/canvas/Plotter.js	(revision 146)
@@ -46,6 +46,9 @@
     construct: function() {
         this.base(arguments);
+
+        this._setLayout(new qx.ui.layout.Basic());
+
         this.setCursor("crosshair");
-        
+
         var v = new Array;
         v.xmin = 0.1;
@@ -62,29 +65,30 @@
         this.w = w;
 
-        var tracker = new qx.legacy.ui.basic.Atom("X:<br>Y:");
-        tracker.setBorder("groove");
+        var tracker = new qx.ui.basic.Label("X:<br>Y:");
+        tracker.setRich(true);
+        tracker.setDecorator(new qx.ui.decoration.Single(1, "solid", "black"));
         tracker.hide();
         tracker.dp = aPoint();
         tracker.vp = aPoint();
         tracker.wp = aPoint();
-        this.add(tracker);
+        
+        this._add(tracker, {left: 20, top:20});
         this.tracker = tracker;
-        
-        this.setHorizontalChildrenAlign("left");
-        this.setVerticalChildrenAlign("top");
         
         this.addListener("mousemove", function(ev) {
                 var tracker = this.tracker;
-                var el = this.getElement();
-                tracker.dp.x = ev.getPageX() -
-                    qx.legacy.html.Location.getClientInnerLeft(el) - 1;
-                tracker.dp.y = ev.getPageY() -
-                    qx.legacy.html.Location.getClientInnerTop(el) - 1;
+                var el = this.getContainerElement().getDomElement();
+                tracker.dp.x = ev.getViewportLeft() -
+                    qx.bom.element.Location.getLeft(el);
+                tracker.dp.y = ev.getViewportTop() -
+                    qx.bom.element.Location.getTop(el);
                 this.dPoint2vPoint(tracker.dp, tracker.vp);
                 this.vPoint2wPoint(tracker.vp, tracker.wp);
-                tracker.setLabel("X: " + pf.util.Format.numPrint(tracker.wp.x) +
+
+                tracker.setValue("X: " + pf.util.Format.numPrint(tracker.wp.x) +
                     "<br>Y: " + pf.util.Format.numPrint(tracker.wp.y));
-                tracker.setLeft(tracker.dp.x + 12);
-                tracker.setTop(tracker.dp.y - 12);
+
+                tracker.setDomLeft(tracker.dp.x + 12);
+                tracker.setDomTop(tracker.dp.y + 12);
                 
                 if (this.isInsideViewport(tracker.vp)) {
@@ -108,6 +112,7 @@
         vPoint2dPoint: function(vp, p)
         {
-            var width  = this.getWidthValue();
-            var height = this.getHeightValue();
+            var dims   = this.getInnerSize();
+            var width  = dims.width;
+            var height = dims.height;
             
             p.x = Math.round(width*vp.x);
@@ -117,6 +122,7 @@
         dPoint2vPoint: function(dp, vp)
         {
-            var width  = this.getWidthValue();
-            var height = this.getHeightValue();
+            var dims   = this.getInnerSize();
+            var width  = dims.width;
+            var height = dims.height;
             
             vp.x = dp.x/width;
@@ -149,6 +155,6 @@
             }
             
-            p1 = aPoint();
-            p2 = aPoint();
+            var p1 = aPoint();
+            var p2 = aPoint();
             
             this.vPoint2dPoint(vp1, p1);
@@ -165,6 +171,6 @@
             }
             
-            p1 = aPoint();
-            p2 = aPoint();
+            var p1 = aPoint();
+            var p2 = aPoint();
             
             this.vPoint2dPoint(vp1, p1);
@@ -197,5 +203,5 @@
             }
             
-            p = aPoint();
+            var p = aPoint();
             
             this.vPoint2dPoint(vp, p);
@@ -241,6 +247,6 @@
             var wp = aPoint();
 
-            dx = new Array;
-            dy = new Array;
+            var dx = new Array;
+            var dy = new Array;
             for (var i = 0; i < x.length; i++) {
                 wp.x = x[i];
@@ -307,4 +313,5 @@
             
             var halign, valign;
+            var wmin, wmax;
             if (axis == "x") {
                 wmin  = w.xmin;
@@ -331,5 +338,5 @@
             var nticks = (nmajor - 1)*2 + 1;
             
-            wstart = Math.floor(wmin/tmajor)*tmajor;
+            var wstart = Math.floor(wmin/tmajor)*tmajor;
             
             for (var i = 0; i < nticks; i++) {
